ARENALIVE_DATABASE = {};
ARENALIVE_DATABASE = ArenaLive_Defaults;
local taintSent = 0;
local hiddenUnitPopupButtons =
	{
		"MOVE_FOCUS_FRAME",
		"LARGE_FOCUS",
	};



function ArenaLive_OnLoad(self)

	self:RegisterEvent("ADDON_LOADED");
end



function ArenaLive_OnUpdate(self, elapsed)

	if ( _G["CompactRaidFrame1"] ) then
		local isSecure, addOn = issecurevariable("CompactRaidFrame1");
		if ( not isSecure ) then
			local msg = "isSecure: "..tostring(isSecure)..", addOn:"..tostring(addOn);
			taintSent = 1;
			ArenaLive_SystemMessage(msg, false);	
		end
	end

end



--[[ ArenaLive_Database_AddAddOn
	Function to add an ArenaLive based AddOn's SavedVariables into the Database table ]]--
function ArenaLive_Database_UpdateAddOn (addonName, savedVariables)

	ARENALIVE_DATABASE[addonName] = savedVariables;

end



function ArenaLive_Database_UpdateSavedVariables (addonName, savedVariables)

	if ( addonName ) then
		savedVariables = ARENALIVE_DATABASE[addonName];
	else
		-- If no addOn Name is given, then we need to update our core saved variables
		savedVariables["options"] = ARENALIVE_DATABASE["options"];

	end

end



function ArenaLive_Database_ReleaseAddOn (addonName, savedVariables)

	if ( (not addonName) or (not savedVariables) ) then
		return;
	end
	
	savedVariables = ARENALIVE_DATABASE[addonName];
	ARENALIVE_DATABASE[addonName] = nil;
end



function ArenaLive_SystemMessage (msg, isDebug)
	local debugState = ARENALIVE_DATABASE["options"]["debug"]
	if ( isDebug and not debugState ) then
		return;
	elseif ( isDebug and debugState ) then
	
		print("|cFFFF0000ArenaLive Debug:|r "..tostring(msg));
	
	else
		print("|cFFFF0000ArenaLive:|r "..tostring(msg));
	end
	
end



function ArenaLive_ToggleBlizzFrame(blizzFrame, state)

	if ( state ) then
		blizzFrame:Hide();
		blizzFrame.Show = function() end;
	else
		blizzFrame.Show = nil;
		blizzFrame:Show();
	end

end



function ArenaLive_OnEvent(self, event, ...)
	
	local arg1 = ...
	
	if ( event == "ADDON_LOADED" and arg1 == "ArenaLiveCore" ) then
	
		-- If there are SavedVariables, we set up our Database. If not, we set the Defaults as SavedVariables.
		if (not ArenaLive_SavedVariables ) then
			ArenaLive_SavedVariables = ArenaLive_Defaults;
		else
			ARENALIVE_DATABASE = ArenaLive_SavedVariables;
		end
	end
end



function ArenaLive_SecureUnitButton_OnLoad(self, unit, menufunc, registerUnitWatch)
    
	self.registerUnitWatch = registerUnitWatch;
	self:SetAttribute("*type1", "target");
	
	if ( menufunc ) then
		self:SetAttribute("*type2", "menu");
		self.menu = menufunc;
	else
		self:SetAttribute("*type2", "togglemenu");
	end
    
    self:SetAttribute("unit", unit);
    	
end


function ArenaLive_UnitPopupHideFunctions(arg)	
	
	for index, value in ipairs(UnitPopupMenus[UIDROPDOWNMENU_INIT_MENU.which]) do
		
		if (UnitPopupShown[1][index] == 1) then
			for _, v in ipairs(hiddenUnitPopupButtons) do	
				if (v == value) then
					UnitPopupShown[1][index] = 0
					break;
				end
			end
		end
		
	end
end
hooksecurefunc("UnitPopup_HideButtons", ArenaLive_UnitPopupHideFunctions)